#ifndef bqtBSPhh
#define bqtBSPhh

class bsp : public ptrable
{
	/* List of all walls residing inside this square */
	std::vector<unsigned> wallids;
	
	/* Smaller corner, bigger corner, dividing point */
	XYZ p1, p2, middle;
	
	/* Subsquares in eight corners */
	autoptr<bsp>
	    nwu, swu, neu, seu,
	    nwd, swd, ned, sed;
public:
	bsp() { }
	~bsp() { }
	bsp(const XYZ &a, const XYZ &b, unsigned wc);
	
	/* Splits this node if it seems wise.
	 * The parameter is a pointer to the wall list.
	 * wallids are indexes to this list.
	 */
	void Split(const MapWall *wallmap);
	
	void SubSplit(autoptr<bsp> &dest, const XYZ &a, const XYZ &b,
	              const MapWall *wallmap);
};

#endif
