#include "map.hh"
#include "bsp.hh"

Map::Map() : Walls(NULL), WallCount(0)
{
}

Map::~Map()
{
    if(Walls)delete[] Walls;
}

void Map::Load(const v3 *verts, unsigned vcount,
               const wall *walls, unsigned wcount)
{
    if(Walls) { delete[] Walls; Walls=NULL; }
    Walls = new MapWall[WallCount = wcount];
    FLOAT mix=0,miy=0,miz=0, max=0,may=0,maz=0;
    for(unsigned w=0; w<wcount; ++w)
    {
        Walls[w] = MapWall(walls[w], verts);
        if(!w || Walls[w].minx()<mix)mix=Walls[w].minx();
        if(!w || Walls[w].miny()<miy)miy=Walls[w].miny();
        if(!w || Walls[w].minz()<miz)miz=Walls[w].minz();
        if(!w || Walls[w].maxx()>max)max=Walls[w].maxx();
        if(!w || Walls[w].maxy()>may)may=Walls[w].maxy();
        if(!w || Walls[w].maxz()>maz)maz=Walls[w].maxz();
    }
    
    tree = new bsp(XYZ(mix,miy,miz), XYZ(max,may,maz), wcount);
    tree->Split(Walls);
}

MapWall::MapWall(const wall &w, const v3 *verts) : wall(w)
{
    const v3 &a = verts[v1], &b = verts[v2];
    p1.Set(a.x, a.y, a.z);
    p2.Set(b.x, b.y, b.z);
}

bool MapWall::hits(const XYZ &a, const XYZ &b) const
{
    return (a.x <= maxx() && b.x >= minx())
        && (a.y <= maxy() && b.y >= miny())
        && (a.z <= maxz() && b.z >= minz());
}

Map *LoadMap(const v3 *verts, unsigned vcount,
             const wall *walls, unsigned wcount)
{
    Map *tmp = new Map();
    tmp->Load(verts, vcount, walls, wcount);
    return tmp;
}
