#include "xyz.hh"
#include "mapdefs.hh"

/* This is in memory. */
class MapWall : public wall
{
public:
	XYZ p1, p2;
public:
	MapWall() { }
	MapWall(const wall &w, const v3 *verts);
	
	bool hits(const XYZ &a, const XYZ &b) const;
	
	inline const FLOAT minx() const { return p1.x <? p2.x; }
	inline const FLOAT miny() const { return p1.y <? p2.y; }
	inline const FLOAT minz() const { return p1.z <? p2.z; }
	inline const FLOAT maxx() const { return p1.x >? p2.x; }
	inline const FLOAT maxy() const { return p1.y >? p2.y; }
	inline const FLOAT maxz() const { return p1.z >? p2.z; }
};

#include <vector>
#include "autoptr"
class Map
{
	MapWall *Walls;
	unsigned WallCount;
	
	autoptr<class bsp> tree;

public:
	Map();
	~Map();

	void Load(const v3 *verts, unsigned vcount,
	          const wall *walls, unsigned wcount);
	
	MapWall *FindObstacle(const XYZ &eye, const XYZ &dir);
};
