#include "mapdefs.hh"

static const v3 verts[] =
{
    /* 0,1,2,3, 4,5,6,7 */
    {  0,  0, 0},
    {  0,500, 0},
    {500,500, 0},
    {500,  0, 0},
    {  0,  0,80},
    {  0,500,80},
    {500,500,80},
    {500,  0,80},
    
    /* 8,9,10,11, 12,13,14,15 */
    {200,100, 0},
    {300,100, 0},
    {200,200, 0},
    {210,200, 0},
    {290,200, 0},
    {300,200, 0},
    {290, 40, 0},
    {210, 40, 0},
    
    /* 16,17,18,19, 20,21,22,23 */
    {200,100,70},
    {300,100,70},
    {200,200,70},
    {210,200,50},
    {290,200,50},
    {300,200,70},
    {290, 40,50},
    {210, 40,50},
};

/* A field with a tunnel going through solid wall. */
static const wall walls[] =
{
    { 0, 2}, /* floor */
    
    /* 1..5 */
    { 0, 7}, /* outer wall begin */
    { 3, 6},
    { 2, 5},
    { 1, 4}, /* outer wall end */
    
    /* 6,7,8,9, 10,11,12,13 */    
    {12,21}, /* - solid wall front */
    {13,17}, /* | solid wall side */
    { 9,16}, /* _ solid wall back */
    { 8,18}, /* | solid wall side */
    {10,19}, /* - solid wall front */
    {11,23}, /* | inside wall edges */
    {15,22}, /* ~ */
    {14,20}, /* | */
    
    /* 14,15 */
    {16,21}, /* subtop ceiling */
    {21,19}, /* inner ceiling */

    /* 16 */
    {12,19} /* middle top wall */
};

class Map *build(void)
{
    return LoadMap(verts, (sizeof verts) / (sizeof(verts[0])),
	               walls, (sizeof walls) / (sizeof(walls[0])));
}
